
#ifndef _MANAGEMENT_DOMAIN_
#define _MANAGEMENT_DOMAIN_

//
// Licensed to the Apache Software Foundation (ASF) under one
// or more contributor license agreements.  See the NOTICE file
// distributed with this work for additional information
// regarding copyright ownership.  The ASF licenses this file
// to you under the Apache License, Version 2.0 (the
// "License"); you may not use this file except in compliance
// with the License.  You may obtain a copy of the License at
// 
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing,
// software distributed under the License is distributed on an
// "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
// KIND, either express or implied.  See the License for the
// specific language governing permissions and limitations
// under the License.
//

// This source file was created by a code generator.
// Please do not edit.

#include "qpid/management/ManagementObject.h"
#include "qpid/framing/FieldTable.h"
#include "qpid/framing/Uuid.h"

namespace qpid {
    namespace management {
        class ManagementAgent;
    }
}

namespace qmf {
namespace com {
namespace redhat {
namespace libvirt {


class Domain : public ::qpid::management::ManagementObject
{
  private:

    static std::string packageName;
    static std::string className;
    static uint8_t     md5Sum[16];


    // Properties
    std::string uuid;
    std::string name;
    int64_t id;
    ::qpid::management::ObjectId node;
    std::string state;
    uint32_t numVcpus;
    std::string active;

    // Statistics
    uint64_t  maximumMemory;
    uint64_t  memory;
    uint64_t  cpuTime;


    // Private Methods
    static void writeSchema(::qpid::framing::Buffer& buf);
    void writeProperties(::qpid::framing::Buffer& buf);
    void writeStatistics(::qpid::framing::Buffer& buf,
                         bool skipHeaders = false);
    void doMethod(std::string& methodName,
                  ::qpid::framing::Buffer& inBuf,
                  ::qpid::framing::Buffer& outBuf);
    writeSchemaCall_t getWriteSchemaCall() { return writeSchema; }

  public:

    Domain(::qpid::management::ManagementAgent* agent,
                            ::qpid::management::Manageable* coreObject, ::qpid::management::Manageable* _parent, const std::string& _uuid, const std::string& _name);
    ~Domain();

    

    static void registerSelf(::qpid::management::ManagementAgent* agent);
    std::string& getPackageName() const { return packageName; }
    std::string& getClassName() const { return className; }
    uint8_t* getMd5Sum() const { return md5Sum; }

    // Method IDs
    static const uint32_t METHOD_CREATE = 1;
    static const uint32_t METHOD_DESTROY = 2;
    static const uint32_t METHOD_UNDEFINE = 3;
    static const uint32_t METHOD_SUSPEND = 4;
    static const uint32_t METHOD_RESUME = 5;
    static const uint32_t METHOD_SAVE = 6;
    static const uint32_t METHOD_RESTORE = 7;
    static const uint32_t METHOD_SHUTDOWN = 8;
    static const uint32_t METHOD_REBOOT = 9;
    static const uint32_t METHOD_GETXMLDESC = 10;
    static const uint32_t METHOD_MIGRATE = 11;

    // Accessor Methods
    inline void set_id (int64_t val) {
        ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
        id = val;
        configChanged = true;
    }
    inline int64_t get_id() {
        ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
        return id;
    }
    inline void set_state (const std::string& val) {
        ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
        state = val;
        configChanged = true;
    }
    inline const std::string& get_state() {
        ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
        return state;
    }
    inline void set_numVcpus (uint32_t val) {
        ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
        numVcpus = val;
        configChanged = true;
    }
    inline uint32_t get_numVcpus() {
        ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
        return numVcpus;
    }
    inline void set_active (const std::string& val) {
        ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
        active = val;
        configChanged = true;
    }
    inline const std::string& get_active() {
        ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
        return active;
    }
    inline void set_maximumMemory (uint64_t val) {
        ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
        maximumMemory = val;
        instChanged = true;
    }
    inline uint64_t get_maximumMemory() {
        ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
        return maximumMemory;
    }
    inline void set_memory (uint64_t val) {
        ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
        memory = val;
        instChanged = true;
    }
    inline uint64_t get_memory() {
        ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
        return memory;
    }
    inline void set_cpuTime (uint64_t val) {
        ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
        cpuTime = val;
        instChanged = true;
    }
    inline uint64_t get_cpuTime() {
        ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
        return cpuTime;
    }

};

}}}}

#endif  /*!_MANAGEMENT_DOMAIN_*/
