
//
// Licensed to the Apache Software Foundation (ASF) under one
// or more contributor license agreements.  See the NOTICE file
// distributed with this work for additional information
// regarding copyright ownership.  The ASF licenses this file
// to you under the Apache License, Version 2.0 (the
// "License"); you may not use this file except in compliance
// with the License.  You may obtain a copy of the License at
// 
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing,
// software distributed under the License is distributed on an
// "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
// KIND, either express or implied.  See the License for the
// specific language governing permissions and limitations
// under the License.
//

// This source file was created by a code generator.
// Please do not edit.

#include "qpid/log/Statement.h"
#include "qpid/framing/FieldTable.h"
#include "qpid/management/Manageable.h" 
#include "qpid/agent/ManagementAgent.h"
#include "Node.h"
#include "ArgsNodeDomainDefineXML.h"
#include "ArgsNodeStoragePoolDefineXML.h"
#include "ArgsNodeFindStoragePoolSources.h"
#include "ArgsNodeStoragePoolCreateXML.h"


using namespace qmf::com::redhat::libvirt;
using namespace qpid::framing;
using           qpid::management::ManagementAgent;
using           qpid::management::Manageable;
using           qpid::management::ManagementObject;
using           qpid::management::Args;
using           std::string;

string  Node::packageName  = string ("com.redhat.libvirt");
string  Node::className    = string ("node");
uint8_t Node::md5Sum[16]   =
    {0x7d,0x9d,0xa6,0x28,0x38,0x81,0xa1,0x14,0x72,0xd1,0x90,0xc4,0xae,0x9e,0x4f,0x43};

Node::Node (ManagementAgent*, Manageable* _core, const std::string& _hostname, const std::string& _uri, const std::string& _libvirtVersion, const std::string& _apiVersion, const std::string& _hypervisorVersion, const std::string& _hypervisorType, const std::string& _model, uint64_t _memory, uint32_t _cpus, uint32_t _mhz, uint32_t _nodes, uint32_t _sockets, uint32_t _cores, uint32_t _threads) :
    ManagementObject(_core),hostname(_hostname),uri(_uri),libvirtVersion(_libvirtVersion),apiVersion(_apiVersion),hypervisorVersion(_hypervisorVersion),hypervisorType(_hypervisorType),model(_model),memory(_memory),cpus(_cpus),mhz(_mhz),nodes(_nodes),sockets(_sockets),cores(_cores),threads(_threads)
{
    



}

Node::~Node ()
{

}

namespace {
    const string NAME("name");
    const string TYPE("type");
    const string ACCESS("access");
    const string IS_INDEX("index");
    const string IS_OPTIONAL("optional");
    const string UNIT("unit");
    const string MIN("min");
    const string MAX("max");
    const string MAXLEN("maxlen");
    const string DESC("desc");
    const string ARGCOUNT("argCount");
    const string ARGS("args");
    const string DIR("dir");
    const string DEFAULT("default");
}

void Node::registerSelf(ManagementAgent* agent)
{
    agent->registerClass(packageName, className, md5Sum, writeSchema);
}

void Node::writeSchema (Buffer& buf)
{
    FieldTable ft;

    // Schema class header:
    buf.putOctet       (CLASS_KIND_TABLE);
    buf.putShortString (packageName); // Package Name
    buf.putShortString (className);   // Class Name
    buf.putBin128      (md5Sum);      // Schema Hash
    buf.putOctet       (0);           // No Superclass
    buf.putShort       (14); // Config Element Count
    buf.putShort       (0); // Inst Element Count
    buf.putShort       (4); // Method Count

    // Properties
    ft.clear();
    ft.setString (NAME, "hostname");
    ft.setInt    (TYPE, TYPE_SSTR);
    ft.setInt    (ACCESS, ACCESS_RC);
    ft.setInt    (IS_INDEX, 0);
    ft.setInt    (IS_OPTIONAL, 0);
    ft.setString (DESC,   "Host name");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME, "uri");
    ft.setInt    (TYPE, TYPE_SSTR);
    ft.setInt    (ACCESS, ACCESS_RC);
    ft.setInt    (IS_INDEX, 0);
    ft.setInt    (IS_OPTIONAL, 0);
    ft.setString (DESC,   "URI of libvirt");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME, "libvirtVersion");
    ft.setInt    (TYPE, TYPE_SSTR);
    ft.setInt    (ACCESS, ACCESS_RC);
    ft.setInt    (IS_INDEX, 0);
    ft.setInt    (IS_OPTIONAL, 0);
    ft.setString (DESC,   "Version of libvirt on the managed node");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME, "apiVersion");
    ft.setInt    (TYPE, TYPE_SSTR);
    ft.setInt    (ACCESS, ACCESS_RC);
    ft.setInt    (IS_INDEX, 0);
    ft.setInt    (IS_OPTIONAL, 0);
    ft.setString (DESC,   "Version of libvirt API on the managed node");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME, "hypervisorVersion");
    ft.setInt    (TYPE, TYPE_SSTR);
    ft.setInt    (ACCESS, ACCESS_RC);
    ft.setInt    (IS_INDEX, 0);
    ft.setInt    (IS_OPTIONAL, 0);
    ft.setString (DESC,   "Hypervisor Version");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME, "hypervisorType");
    ft.setInt    (TYPE, TYPE_SSTR);
    ft.setInt    (ACCESS, ACCESS_RC);
    ft.setInt    (IS_INDEX, 0);
    ft.setInt    (IS_OPTIONAL, 0);
    ft.setString (DESC,   "Hypervisor type");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME, "model");
    ft.setInt    (TYPE, TYPE_SSTR);
    ft.setInt    (ACCESS, ACCESS_RC);
    ft.setInt    (IS_INDEX, 0);
    ft.setInt    (IS_OPTIONAL, 0);
    ft.setString (DESC,   "CPU Model");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME, "memory");
    ft.setInt    (TYPE, TYPE_U64);
    ft.setInt    (ACCESS, ACCESS_RC);
    ft.setInt    (IS_INDEX, 0);
    ft.setInt    (IS_OPTIONAL, 0);
    ft.setString (DESC,   "Host memory");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME, "cpus");
    ft.setInt    (TYPE, TYPE_U32);
    ft.setInt    (ACCESS, ACCESS_RC);
    ft.setInt    (IS_INDEX, 0);
    ft.setInt    (IS_OPTIONAL, 0);
    ft.setString (DESC,   "Number of CPUS");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME, "mhz");
    ft.setInt    (TYPE, TYPE_U32);
    ft.setInt    (ACCESS, ACCESS_RC);
    ft.setInt    (IS_INDEX, 0);
    ft.setInt    (IS_OPTIONAL, 0);
    ft.setString (DESC,   "MHz of CPUs");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME, "nodes");
    ft.setInt    (TYPE, TYPE_U32);
    ft.setInt    (ACCESS, ACCESS_RC);
    ft.setInt    (IS_INDEX, 0);
    ft.setInt    (IS_OPTIONAL, 0);
    ft.setString (DESC,   "Number of NUMA cells.");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME, "sockets");
    ft.setInt    (TYPE, TYPE_U32);
    ft.setInt    (ACCESS, ACCESS_RC);
    ft.setInt    (IS_INDEX, 0);
    ft.setInt    (IS_OPTIONAL, 0);
    ft.setString (DESC,   "Number of CPU Sockets per node");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME, "cores");
    ft.setInt    (TYPE, TYPE_U32);
    ft.setInt    (ACCESS, ACCESS_RC);
    ft.setInt    (IS_INDEX, 0);
    ft.setInt    (IS_OPTIONAL, 0);
    ft.setString (DESC,   "Number of cores per socket");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME, "threads");
    ft.setInt    (TYPE, TYPE_U32);
    ft.setInt    (ACCESS, ACCESS_RC);
    ft.setInt    (IS_INDEX, 0);
    ft.setInt    (IS_OPTIONAL, 0);
    ft.setString (DESC,   "Number of threads per core");
    buf.put (ft);


    // Statistics

    // Methods
    ft.clear();
    ft.setString (NAME,     "domainDefineXML");
    ft.setInt    (ARGCOUNT, 2);
    ft.setString (DESC,     "Define a new domain, but does not start it.");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME,    "xmlDesc");
    ft.setInt    (TYPE,    TYPE_LSTR);
    ft.setString (DIR,     "I");
    ft.setString (DESC,    "XML domain description");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME,    "domain");
    ft.setInt    (TYPE,    TYPE_REF);
    ft.setString (DIR,     "O");
    ft.setString (DESC,    "Newly created domain object");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME,     "storagePoolDefineXML");
    ft.setInt    (ARGCOUNT, 2);
    ft.setString (DESC,     "Define a new inactive storage pool based on its XML description. The pool is persistent, until explicitly undefined.");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME,    "xmlDesc");
    ft.setInt    (TYPE,    TYPE_LSTR);
    ft.setString (DIR,     "I");
    ft.setString (DESC,    "XML Description of the storage pool");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME,    "pool");
    ft.setInt    (TYPE,    TYPE_REF);
    ft.setString (DIR,     "O");
    ft.setString (DESC,    "Newly created storage pool");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME,     "findStoragePoolSources");
    ft.setInt    (ARGCOUNT, 3);
    ft.setString (DESC,     "Talks to a storage backend and attempts to auto-discover the set of available storage pool sources.");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME,    "type");
    ft.setInt    (TYPE,    TYPE_LSTR);
    ft.setString (DIR,     "I");
    ft.setString (DESC,    "Type of storage pool sources to discover.");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME,    "srcSpec");
    ft.setInt    (TYPE,    TYPE_LSTR);
    ft.setString (DIR,     "I");
    ft.setString (DESC,    "XML document specifying discovery source");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME,    "xmlDesc");
    ft.setInt    (TYPE,    TYPE_LSTR);
    ft.setString (DIR,     "O");
    ft.setString (DESC,    "XML document consisting of a SourceList element containing a source document appropriate to the given pool type for each discovered source.");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME,     "storagePoolCreateXML");
    ft.setInt    (ARGCOUNT, 2);
    ft.setString (DESC,     "Create a new storage based on its XML description. The pool is not persistent, so its definition will disappear when it is destroyed, or if the host is restarted");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME,    "xmlDesc");
    ft.setInt    (TYPE,    TYPE_LSTR);
    ft.setString (DIR,     "I");
    ft.setString (DESC,    "XML Description of the storage pool");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME,    "pool");
    ft.setInt    (TYPE,    TYPE_REF);
    ft.setString (DIR,     "O");
    ft.setString (DESC,    "Newly created storage pool");
    buf.put (ft);


}



void Node::writeProperties (Buffer& buf)
{
    ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
    configChanged = false;

    writeTimestamps (buf);

    buf.putShortString(hostname);
    buf.putShortString(uri);
    buf.putShortString(libvirtVersion);
    buf.putShortString(apiVersion);
    buf.putShortString(hypervisorVersion);
    buf.putShortString(hypervisorType);
    buf.putShortString(model);
    buf.putLongLong(memory);
    buf.putLong(cpus);
    buf.putLong(mhz);
    buf.putLong(nodes);
    buf.putLong(sockets);
    buf.putLong(cores);
    buf.putLong(threads);

}

void Node::writeStatistics (Buffer& buf, bool skipHeaders)
{
    ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
    instChanged = false;



    if (!skipHeaders)
        writeTimestamps (buf);


    // Maintenance of hi-lo statistics


}

void Node::doMethod (string& methodName, Buffer& inBuf, Buffer& outBuf)
{
    Manageable::status_t status = Manageable::STATUS_UNKNOWN_METHOD;
    std::string          text;


    if (methodName == "domainDefineXML") {
        ArgsNodeDomainDefineXML ioArgs;
        inBuf.getMediumString(ioArgs.i_xmlDesc);
        status = coreObject->ManagementMethod (METHOD_DOMAINDEFINEXML, ioArgs, text);
        outBuf.putLong        (status);
        outBuf.putMediumString(::qpid::management::Manageable::StatusText (status, text));
        ioArgs.o_domain.encode(outBuf);
        return;
    }

    if (methodName == "storagePoolDefineXML") {
        ArgsNodeStoragePoolDefineXML ioArgs;
        inBuf.getMediumString(ioArgs.i_xmlDesc);
        status = coreObject->ManagementMethod (METHOD_STORAGEPOOLDEFINEXML, ioArgs, text);
        outBuf.putLong        (status);
        outBuf.putMediumString(::qpid::management::Manageable::StatusText (status, text));
        ioArgs.o_pool.encode(outBuf);
        return;
    }

    if (methodName == "findStoragePoolSources") {
        ArgsNodeFindStoragePoolSources ioArgs;
        inBuf.getMediumString(ioArgs.i_type);
        inBuf.getMediumString(ioArgs.i_srcSpec);
        status = coreObject->ManagementMethod (METHOD_FINDSTORAGEPOOLSOURCES, ioArgs, text);
        outBuf.putLong        (status);
        outBuf.putMediumString(::qpid::management::Manageable::StatusText (status, text));
        outBuf.putMediumString(ioArgs.o_xmlDesc);
        return;
    }

    if (methodName == "storagePoolCreateXML") {
        ArgsNodeStoragePoolCreateXML ioArgs;
        inBuf.getMediumString(ioArgs.i_xmlDesc);
        status = coreObject->ManagementMethod (METHOD_STORAGEPOOLCREATEXML, ioArgs, text);
        outBuf.putLong        (status);
        outBuf.putMediumString(::qpid::management::Manageable::StatusText (status, text));
        ioArgs.o_pool.encode(outBuf);
        return;
    }

    outBuf.putLong(status);
    outBuf.putShortString(Manageable::StatusText(status, text));
}
