
//
// Licensed to the Apache Software Foundation (ASF) under one
// or more contributor license agreements.  See the NOTICE file
// distributed with this work for additional information
// regarding copyright ownership.  The ASF licenses this file
// to you under the Apache License, Version 2.0 (the
// "License"); you may not use this file except in compliance
// with the License.  You may obtain a copy of the License at
// 
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing,
// software distributed under the License is distributed on an
// "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
// KIND, either express or implied.  See the License for the
// specific language governing permissions and limitations
// under the License.
//

// This source file was created by a code generator.
// Please do not edit.

#include "qpid/log/Statement.h"
#include "qpid/framing/FieldTable.h"
#include "qpid/management/Manageable.h" 
#include "qpid/agent/ManagementAgent.h"
#include "Pool.h"
#include "ArgsPoolGetXMLDesc.h"
#include "ArgsPoolCreateVolumeXML.h"


using namespace qmf::com::redhat::libvirt;
using namespace qpid::framing;
using           qpid::management::ManagementAgent;
using           qpid::management::Manageable;
using           qpid::management::ManagementObject;
using           qpid::management::Args;
using           std::string;

string  Pool::packageName  = string ("com.redhat.libvirt");
string  Pool::className    = string ("pool");
uint8_t Pool::md5Sum[16]   =
    {0xf8,0x1c,0x41,0x89,0x45,0x77,0xf0,0xb2,0xa9,0x4a,0x68,0x44,0x58,0xc,0x1b,0x5b};

Pool::Pool (ManagementAgent*, Manageable* _core, ::qpid::management::Manageable* _parent, const std::string& _uuid, const std::string& _name, const std::string& _parentVolume) :
    ManagementObject(_core),uuid(_uuid),name(_name),parentVolume(_parentVolume)
{
    node = _parent->GetManagementObject ()->getObjectId ();
    state = "";
    capacity = 0;
    allocation = 0;
    available = 0;



}

Pool::~Pool ()
{

}

namespace {
    const string NAME("name");
    const string TYPE("type");
    const string ACCESS("access");
    const string IS_INDEX("index");
    const string IS_OPTIONAL("optional");
    const string UNIT("unit");
    const string MIN("min");
    const string MAX("max");
    const string MAXLEN("maxlen");
    const string DESC("desc");
    const string ARGCOUNT("argCount");
    const string ARGS("args");
    const string DIR("dir");
    const string DEFAULT("default");
}

void Pool::registerSelf(ManagementAgent* agent)
{
    agent->registerClass(packageName, className, md5Sum, writeSchema);
}

void Pool::writeSchema (Buffer& buf)
{
    FieldTable ft;

    // Schema class header:
    buf.putOctet       (CLASS_KIND_TABLE);
    buf.putShortString (packageName); // Package Name
    buf.putShortString (className);   // Class Name
    buf.putBin128      (md5Sum);      // Schema Hash
    buf.putOctet       (0);           // No Superclass
    buf.putShort       (8); // Config Element Count
    buf.putShort       (0); // Inst Element Count
    buf.putShort       (8); // Method Count

    // Properties
    ft.clear();
    ft.setString (NAME, "uuid");
    ft.setInt    (TYPE, TYPE_SSTR);
    ft.setInt    (ACCESS, ACCESS_RC);
    ft.setInt    (IS_INDEX, 0);
    ft.setInt    (IS_OPTIONAL, 0);
    ft.setString (DESC,   "Pool UUID");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME, "name");
    ft.setInt    (TYPE, TYPE_SSTR);
    ft.setInt    (ACCESS, ACCESS_RC);
    ft.setInt    (IS_INDEX, 0);
    ft.setInt    (IS_OPTIONAL, 0);
    ft.setString (DESC,   "Pool name");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME, "parentVolume");
    ft.setInt    (TYPE, TYPE_SSTR);
    ft.setInt    (ACCESS, ACCESS_RC);
    ft.setInt    (IS_INDEX, 0);
    ft.setInt    (IS_OPTIONAL, 0);
    ft.setString (DESC,   "If this pool is an LVM pool, this will contain the parent volume path.");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME, "state");
    ft.setInt    (TYPE, TYPE_SSTR);
    ft.setInt    (ACCESS, ACCESS_RO);
    ft.setInt    (IS_INDEX, 0);
    ft.setInt    (IS_OPTIONAL, 0);
    ft.setString (DESC,   "Pool state");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME, "capacity");
    ft.setInt    (TYPE, TYPE_U64);
    ft.setInt    (ACCESS, ACCESS_RO);
    ft.setInt    (IS_INDEX, 0);
    ft.setInt    (IS_OPTIONAL, 0);
    ft.setString (DESC,   "Pool size in bytes");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME, "allocation");
    ft.setInt    (TYPE, TYPE_U64);
    ft.setInt    (ACCESS, ACCESS_RO);
    ft.setInt    (IS_INDEX, 0);
    ft.setInt    (IS_OPTIONAL, 0);
    ft.setString (DESC,   "Current allocation in bytes");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME, "available");
    ft.setInt    (TYPE, TYPE_U64);
    ft.setInt    (ACCESS, ACCESS_RO);
    ft.setInt    (IS_INDEX, 0);
    ft.setInt    (IS_OPTIONAL, 0);
    ft.setString (DESC,   "Available space in bytes");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME, "node");
    ft.setInt    (TYPE, TYPE_REF);
    ft.setInt    (ACCESS, ACCESS_RC);
    ft.setInt    (IS_INDEX, 1);
    ft.setInt    (IS_OPTIONAL, 0);
    ft.setString (DESC,   "Node of this storage pool");
    buf.put (ft);


    // Statistics

    // Methods
    ft.clear();
    ft.setString (NAME,     "getXMLDesc");
    ft.setInt    (ARGCOUNT, 1);
    ft.setString (DESC,     "Return an XML description of the storage pool.");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME,    "description");
    ft.setInt    (TYPE,    TYPE_LSTR);
    ft.setString (DIR,     "O");
    ft.setString (DESC,    "XML description of the storage pool.");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME,     "create");
    ft.setInt    (ARGCOUNT, 0);
    ft.setString (DESC,     "Starts an inactive storage pool.");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME,     "build");
    ft.setInt    (ARGCOUNT, 0);
    ft.setString (DESC,     "Build the underlying storage pool.");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME,     "destroy");
    ft.setInt    (ARGCOUNT, 0);
    ft.setString (DESC,     "Destroy an active storage pool. This will deactivate the pool on the host, but keep any persistent config associated with it. If it has a persistent config it can later be restarted with a create() call");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME,     "delete");
    ft.setInt    (ARGCOUNT, 0);
    ft.setString (DESC,     "Destroy the pool and delete its definition");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME,     "undefine");
    ft.setInt    (ARGCOUNT, 0);
    ft.setString (DESC,     "Undefine an inactive storage pool.");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME,     "createVolumeXML");
    ft.setInt    (ARGCOUNT, 2);
    ft.setString (DESC,     "Create a storage volume within a pool based on an XML description.  Not all pool types support volume creation.");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME,    "xmlDesc");
    ft.setInt    (TYPE,    TYPE_LSTR);
    ft.setString (DIR,     "I");
    ft.setString (DESC,    "XML Description of the volume to create");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME,    "volume");
    ft.setInt    (TYPE,    TYPE_REF);
    ft.setString (DIR,     "O");
    ft.setString (DESC,    "Newly created volume");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME,     "refresh");
    ft.setInt    (ARGCOUNT, 0);
    ft.setString (DESC,     "Request that the pool refresh its list of volumes.");
    buf.put (ft);


}



void Pool::writeProperties (Buffer& buf)
{
    ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
    configChanged = false;

    writeTimestamps (buf);

    buf.putShortString(uuid);
    buf.putShortString(name);
    buf.putShortString(parentVolume);
    buf.putShortString(state);
    buf.putLongLong(capacity);
    buf.putLongLong(allocation);
    buf.putLongLong(available);
    node.encode(buf);

}

void Pool::writeStatistics (Buffer& buf, bool skipHeaders)
{
    ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
    instChanged = false;



    if (!skipHeaders)
        writeTimestamps (buf);


    // Maintenance of hi-lo statistics


}

void Pool::doMethod (string& methodName, Buffer& inBuf, Buffer& outBuf)
{
    Manageable::status_t status = Manageable::STATUS_UNKNOWN_METHOD;
    std::string          text;


    if (methodName == "getXMLDesc") {
        ArgsPoolGetXMLDesc ioArgs;
        status = coreObject->ManagementMethod (METHOD_GETXMLDESC, ioArgs, text);
        outBuf.putLong        (status);
        outBuf.putMediumString(::qpid::management::Manageable::StatusText (status, text));
        outBuf.putMediumString(ioArgs.o_description);
        return;
    }

    if (methodName == "create") {
        ::qpid::management::ArgsNone ioArgs;
        status = coreObject->ManagementMethod (METHOD_CREATE, ioArgs, text);
        outBuf.putLong        (status);
        outBuf.putMediumString(::qpid::management::Manageable::StatusText (status, text));
        return;
    }

    if (methodName == "build") {
        ::qpid::management::ArgsNone ioArgs;
        status = coreObject->ManagementMethod (METHOD_BUILD, ioArgs, text);
        outBuf.putLong        (status);
        outBuf.putMediumString(::qpid::management::Manageable::StatusText (status, text));
        return;
    }

    if (methodName == "destroy") {
        ::qpid::management::ArgsNone ioArgs;
        status = coreObject->ManagementMethod (METHOD_DESTROY, ioArgs, text);
        outBuf.putLong        (status);
        outBuf.putMediumString(::qpid::management::Manageable::StatusText (status, text));
        return;
    }

    if (methodName == "delete") {
        ::qpid::management::ArgsNone ioArgs;
        status = coreObject->ManagementMethod (METHOD_DELETE, ioArgs, text);
        outBuf.putLong        (status);
        outBuf.putMediumString(::qpid::management::Manageable::StatusText (status, text));
        return;
    }

    if (methodName == "undefine") {
        ::qpid::management::ArgsNone ioArgs;
        status = coreObject->ManagementMethod (METHOD_UNDEFINE, ioArgs, text);
        outBuf.putLong        (status);
        outBuf.putMediumString(::qpid::management::Manageable::StatusText (status, text));
        return;
    }

    if (methodName == "createVolumeXML") {
        ArgsPoolCreateVolumeXML ioArgs;
        inBuf.getMediumString(ioArgs.i_xmlDesc);
        status = coreObject->ManagementMethod (METHOD_CREATEVOLUMEXML, ioArgs, text);
        outBuf.putLong        (status);
        outBuf.putMediumString(::qpid::management::Manageable::StatusText (status, text));
        ioArgs.o_volume.encode(outBuf);
        return;
    }

    if (methodName == "refresh") {
        ::qpid::management::ArgsNone ioArgs;
        status = coreObject->ManagementMethod (METHOD_REFRESH, ioArgs, text);
        outBuf.putLong        (status);
        outBuf.putMediumString(::qpid::management::Manageable::StatusText (status, text));
        return;
    }

    outBuf.putLong(status);
    outBuf.putShortString(Manageable::StatusText(status, text));
}
