
#ifndef _MANAGEMENT_VOLUME_
#define _MANAGEMENT_VOLUME_

//
// Licensed to the Apache Software Foundation (ASF) under one
// or more contributor license agreements.  See the NOTICE file
// distributed with this work for additional information
// regarding copyright ownership.  The ASF licenses this file
// to you under the Apache License, Version 2.0 (the
// "License"); you may not use this file except in compliance
// with the License.  You may obtain a copy of the License at
// 
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing,
// software distributed under the License is distributed on an
// "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
// KIND, either express or implied.  See the License for the
// specific language governing permissions and limitations
// under the License.
//

// This source file was created by a code generator.
// Please do not edit.

#include "qpid/management/ManagementObject.h"
#include "qpid/framing/FieldTable.h"
#include "qpid/framing/Uuid.h"

namespace qpid {
    namespace management {
        class ManagementAgent;
    }
}

namespace qmf {
namespace com {
namespace redhat {
namespace libvirt {


class Volume : public ::qpid::management::ManagementObject
{
  private:

    static std::string packageName;
    static std::string className;
    static uint8_t     md5Sum[16];


    // Properties
    std::string key;
    std::string path;
    std::string name;
    std::string childLVMName;
    uint64_t capacity;
    uint64_t allocation;
    ::qpid::management::ObjectId storagePool;

    // Statistics


    // Private Methods
    static void writeSchema(::qpid::framing::Buffer& buf);
    void writeProperties(::qpid::framing::Buffer& buf);
    void writeStatistics(::qpid::framing::Buffer& buf,
                         bool skipHeaders = false);
    void doMethod(std::string& methodName,
                  ::qpid::framing::Buffer& inBuf,
                  ::qpid::framing::Buffer& outBuf);
    writeSchemaCall_t getWriteSchemaCall() { return writeSchema; }

    // Stub for getInstChanged.  There are no statistics in this class.
    bool getInstChanged() { return false; }
    bool hasInst() { return false; }

  public:

    Volume(::qpid::management::ManagementAgent* agent,
                            ::qpid::management::Manageable* coreObject, ::qpid::management::Manageable* _parent, const std::string& _key, const std::string& _path, const std::string& _name, const std::string& _childLVMName);
    ~Volume();

    

    static void registerSelf(::qpid::management::ManagementAgent* agent);
    std::string& getPackageName() const { return packageName; }
    std::string& getClassName() const { return className; }
    uint8_t* getMd5Sum() const { return md5Sum; }

    // Method IDs
    static const uint32_t METHOD_GETXMLDESC = 1;
    static const uint32_t METHOD_DELETE = 2;

    // Accessor Methods
    inline void set_capacity (uint64_t val) {
        ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
        capacity = val;
        configChanged = true;
    }
    inline uint64_t get_capacity() {
        ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
        return capacity;
    }
    inline void set_allocation (uint64_t val) {
        ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
        allocation = val;
        configChanged = true;
    }
    inline uint64_t get_allocation() {
        ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
        return allocation;
    }

};

}}}}

#endif  /*!_MANAGEMENT_VOLUME_*/
